DECLARE @TYPE nchar(1)
DECLARE @MAC_old nvarchar(32)   --Length is 17
DECLARE @MAC_new nvarchar(32)  --Length is 17
DECLARE @UUID_old nvarchar(72)   --Length is 36
DECLARE @UUID_new nvarchar(72)  --Length is 36
DECLARE @UUID_reverse nvarchar(36)
DECLARE @intRet int
DECLARE @intError int
SET @TYPE = '$(TYPE)'
SET @MAC_old = '$(MAC_old)'
SET @MAC_new = '$(MAC_new)'
SET @UUID_old = '$(UUID_old)'
SET @UUID_new = '$(UUID_new)'
SET NOCOUNT ON

IF ((@TYPE <> 'M') AND (@TYPE <> 'm') AND (@TYPE <> 'U') AND (@TYPE <> 'u'))
BEGIN
	PRINT ('Parameter is error.')
	RETURN
END

--MACύXꍇ
IF ((@TYPE = 'M') OR (@TYPE = 'm'))
BEGIN
     IF( len(@MAC_old)<>17)
     BEGIN
		PRINT ('Update Failed.')
		PRINT ('The Old MAC ' + @MAC_old + ' is invalid.')
		RETURN
     END
     
     IF( len(@MAC_new)<>17)
     BEGIN
		PRINT ('Update Failed.')
		PRINT ('The New MAC ' + @MAC_new + ' is invalid.')
		RETURN
     END

	--ύXMAC݂邱ƂmF
	IF NOT EXISTS (SELECT * FROM tblDPMClientMAC WHERE MAC = @MAC_old)
	BEGIN
		PRINT ('Update Failed.')
		PRINT ('The MAC ' + @MAC_old + ' is not exist.')
		RETURN
	END

	--ύXMAC݂ȂƂmF
	IF EXISTS (SELECT * FROM tblDPMClientMAC WHERE MAC = @MAC_new)
	BEGIN
		PRINT ('Update MAC Failed.')
		PRINT ('The MAC ' + @MAC_new + ' is exist.')
		RETURN
	END

	UPDATE tblDPMClientMAC SET MAC = @MAC_new WHERE MAC = @MAC_old
	SET @intError = @@Error
	IF( @intError <> 0)
	BEGIN
		PRINT ('Update MAC Failed.')
		PRINT ('Error code = ' + CAST(@intError AS nvarchar(10)))
	END
	ELSE
		PRINT ('Update MAC Success.')
END

--UUIDύXꍇ
ELSE IF ((@TYPE = 'U') OR (@TYPE = 'u'))
BEGIN
    IF( len(@UUID_old)<>36)
     BEGIN
		PRINT ('Update Failed.')
		PRINT ('The Old UUID ' + @UUID_old + ' is invalid.')
		RETURN
     END

     IF( len(@UUID_new)<>36)
     BEGIN
		PRINT ('Update Failed.')
		PRINT ('The New UUID ' + @UUID_new + ' is invalid.')
		RETURN
     END
	--ufReverseUUID()݂Ȃꍇ(DPM5.x)
	IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ufReverseUUID]') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
	BEGIN
   
		--ύXUUID݂邱ƂmF
		IF NOT EXISTS (SELECT * FROM tblDPMClientUUID WHERE UUID = @UUID_old)
		BEGIN
			PRINT ('Update Failed.')
			PRINT ('The UUID ' + @UUID_old + ' is not exist.')
			RETURN
		END
	
		--ύXUUID݂ȂƂmF
		IF EXISTS (SELECT * FROM tblDPMClientUUID WHERE UUID = @UUID_new)
		BEGIN
			PRINT ('Update UUID Failed.')
			PRINT ('The UUID ' + @UUID_new + ' is exist.')
			RETURN
		END
	
		UPDATE tblDPMClientUUID SET UUID = @UUID_new WHERE UUID = @UUID_old
		SET @intError = @@Error
		IF( @intError <> 0)
		BEGIN
			PRINT ('Update UUID Failed.')
			PRINT ('Error code = ' + CAST(@intError AS nvarchar(10)))
		END
		ELSE
			PRINT ('Update UUID Success.')
	END
	
	--ufReverseUUID()݂ꍇ(DPM6.x)
	ELSE
	BEGIN
		--ύXUUID݂邱ƂmF
		SET @UUID_reverse = [dbo].[ufReverseUUID](@UUID_old)
		IF NOT EXISTS (SELECT * FROM tblDPMClientUUID WHERE UUID = @UUID_old OR UUID = @UUID_reverse)
		BEGIN
			PRINT ('Update Failed.')
			PRINT ('The UUID ' + @UUID_old + ' or ' + @UUID_reverse + ' is not exist.')
			RETURN
		END
	
		--ύXUUID݂ȂƂmF
		SET @UUID_reverse = [dbo].[ufReverseUUID](@UUID_new)
		IF EXISTS (SELECT * FROM tblDPMClientUUID WHERE UUID = @UUID_new  OR UUID = @UUID_reverse)
		BEGIN
			PRINT ('Update UUID Failed.')
			PRINT ('The UUID ' + @UUID_new + ' or ' + @UUID_reverse + ' is exist.')
			RETURN
		END
	
		SET @UUID_reverse = [dbo].[ufReverseUUID](@UUID_old)
		UPDATE tblDPMClientUUID SET UUID = @UUID_new WHERE UUID = @UUID_old OR UUID = @UUID_reverse
		SET @intError = @@Error
		IF( @intError <> 0)
		BEGIN
			PRINT ('Update UUID Failed.')
			PRINT ('Error code = ' + CAST(@intError AS nvarchar(10)))
		END
		ELSE
			PRINT ('Update UUID Success.')
	END

END
